package com.platform.controller;

import com.platform.annotation.CanUserUpdateRecord;
import com.platform.entity.Result;
import com.platform.entity.UserLevelEntity;
import com.platform.service.UserLevelService;
import com.platform.utils.PageUtils;
import com.platform.utils.Query;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * Controller
 *
 * @author lipengjun
 * @email 939961241@qq.com
 * @date 2017-08-16 16:52:22
 */
@RestController
@RequestMapping("userlevel")
public class UserLevelController {
    @Autowired
    private UserLevelService userLevelService;

    /**
     * 查看列表
     */
    @RequestMapping("/list")
    
    public Result list(@RequestBody Map<String, Object> params) {
        //查询列表数据
        Query query = new Query(params);

        List<UserLevelEntity> userLevelList = userLevelService.queryList(query);
        int total = userLevelService.queryTotal(query);

        PageUtils pageUtil = new PageUtils(userLevelList, total, query.getLimit(), query.getPage());

        return Result.success( pageUtil);
    }


    /**
     * 查看信息
     */
    @RequestMapping("/info/{id}")
    
    public Result info(@PathVariable("id") Integer id) {
        UserLevelEntity userLevel = userLevelService.queryObject(id);

        return Result.success(userLevel);
    }

    /**
     * 保存
     */
    @CanUserUpdateRecord
    @RequestMapping("/save")
    
    public Result save(@RequestBody UserLevelEntity userLevel) {
        userLevelService.save(userLevel);

        return Result.success();
    }

    /**
     * 修改
     */
    @CanUserUpdateRecord
    @RequestMapping("/update")
    
    public Result update(@RequestBody UserLevelEntity userLevel) {
        userLevelService.update(userLevel);

        return Result.success();
    }

    /**
     * 删除
     */
    @CanUserUpdateRecord
    @RequestMapping("/delete")
    
    public Result delete(@RequestBody Integer[] ids) {
        userLevelService.deleteBatch(ids);

        return Result.success();
    }

    /**
     * 查询所有数据
     *
     * @return
     */
    @RequestMapping("queryAll")
    public Result queryAll(@RequestBody Map<String, Object> params) {
        List<UserLevelEntity> userLevelList = userLevelService.queryList(params);
        return Result.success(userLevelList);
    }
}
